CSEG    SEGMENT PARA  PUBLIC
        ASSUME  CS:CSEG, DS: CSEG, ES: CSEG, SS: CSEG
        ORG     100h

;--------------------------------------
START:
        LEA     SP,HeapStack           ; ⠭ 設 ⥪
        ADD     SP,500H                ; +500H    ணࠬ
        POP     AX                     ; ⠭   
        XOR     AX,AX                  ; PSP.[0]
        PUSH	AX
        CALL    SetEPB                 ; 塞  EPB
        MOV     AH,4AH                 ;  ⥪騩  
        MOV     BX,OFFSET HeapStack    ;  ࠧ஢ ணࠬ+⥪
        ADD     BX,500H
        MOV     CL,4
        SHR     BX,CL
        INC     BX
        INT     21H
        JC      Error                  ; 訡 믮
        CALL    ReadHeader
        MOV     AH,4BH                 ; 㦠  ᢮ 
        MOV     AL,1                   ; ணࠬ, 㪠
        LEA     BX,EPB                 ;  ६ ExeProg
        LEA     DX,ExeProg
;       PUSH    DS
        INT     21H
        JC      Error
        MOV     AH,62H
        INT     21H
        ADD     BX,10H                 ; ࠨ SS:SP  ⥪ 㦥
        MOV     SP,WORD PTR Header.10H                                       
        MOV     AX,BX                  ; ணࠬ
        ADD     AX,WORD PTR Header.0EH
        MOV     SS,AX
        MOV     AX,BX
        ADD     AX,WORD PTR Header.16H
        PUSH    AX                     ; ⠭  室 
        MOV     AX,WORD PTR Header.14H      ; ணࠬ
        PUSH    AX
        SUB     BX,10H
        MOV     DS,BX                  ; ࠨ DS  ES   PSP
        MOV     ES,BX
        LEA     DX,Rest
        MOV     BX,0AH
        MOV     [BX],DX                ;    Rest
        RETF
Rest:                                  ; ⠭ DS ᫥ ࠡ⪨
        PUSH    CS                     ;  㦮 ணࠬ
        POP     DS

        MOV     AL,00
        JMP     EXIT

Exit:
        MOV     AH,4CH
        INT     21H
;--------------------------------------
Error:                                 ; ࠡ稪 訡
        MOV     AH,09H
        LEA     DX,ErrorMessage
        INT     21H
        JMP     EXIT
;--------------------------------------
SetEPB:                                ; ⠭ ᥣ⮢  EPB
        LEA     BX,EPB
        MOV     AX,DS
        MOV     [BX][ 4],AX
        MOV     [BX][ 8],AX
        MOV     [BX][12],AX
        MOV     [BX][16],AX
        MOV     [BX][20],AX
        RETN
;--------------------------------------
;--------------------------------------
ReadHeader:
        MOV     AX,3D02H
        LEA     DX,ExeProg
        INT     21H
        JC      Error
        MOV     Handle,AX
        XOR     AX,AX
        MOV     AH,3FH
        MOV     BX,Handle
        MOV     CX,32
        LEA     DX,Header
        INT     21H
        MOV     AH,3EH
        MOV     BX,Handle
        INT     21H
        RET
;-----------------------  Exec Parameters Block
EPB             DW      0              ; 0000 - ᯮ㥬 ⥪饥 㦥
                DW      OFFSET CMD     ; ⥫  CMD
                DW      0              ;
                DW      OFFSET FCB1    ; ⥫  FCB1
                DW      0              ;
                DW      OFFSET FCB2    ; ⥫  FCB2
                DW      0              ;
                DW      OFFSET Rest    ; ⥫  Rest
                DW      0              ;
                DW      OFFSET Exit    ; ⥫  Exit
                DW      0              ;
CMD             DB      0,13
FCB1            DB      16 DUP (0)
FCB2            DB      16 DUP (0)
ExeProg         DB      'TEST.EXE',0
Handle          DW      0
Header          DB      32 DUP(0)      ;  32- exe-䠩



ErrorMessage    DB      '訡 믮! ⮯ ணࠬ..$'
HeapStack       DW      0

CSEG    ENDS
        END   Start


